<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<databaseChangeLog xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
                   xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                   xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog
                        http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.4.xsd">

    <changeSet id="create_flights" author="db@user">
        <createTable tableName="flights">
            <column name="flight_id" type="int" autoIncrement="true">
                <constraints primaryKey="true" unique="true" nullable="false"/>
            </column>
            <column name="departure_city" type="varchar(50)">
                <constraints nullable="true"/>
            </column>
            <column name="departure_airport" type="varchar(50)">
                <constraints nullable="true"/>
            </column>
            <column name="arrival_city" type="varchar(50)">
                <constraints nullable="true"/>
            </column>
            <column name="arrival_airport" type="varchar(50)">
                <constraints nullable="true"/>
            </column>
            <column name="departure_date" type="timestamp">
                <constraints nullable="true"/>
            </column>
            <column name="arrival_date" type="timestamp">
                <constraints nullable="true"/>
            </column>
            <column name="flight_status" type="enum ('PLANNED', 'FORMED', 'CHECK_IN', 'GATE_CLOSING', 'ON_TIME', 'CANCELLED', 'DELAYED', 'BOARDING', 'DEPARTED')">
                <constraints nullable="true"/>
            </column>
        </createTable>
    </changeSet>

    <changeSet id="create_employees" author="db@user">
        <createTable tableName="employees">
            <column name="employeeId" type="int" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="lastName" type="varchar(50)">
                <constraints nullable="true"/>
            </column>
            <column name="firstName" type="varchar(50)">
                <constraints nullable="true"/>
            </column>
            <column name="employeeRole" type="enum ('PILOT','NAVIGATOR','RADIO_OPERATOR','STEWARDESS')">
                <constraints nullable="true"/>
            </column>
            <column name="sex" type="enum ('MAN', 'WOMAN')">
                <constraints nullable="true"/>
            </column>
            <column name="city" type="varchar(50)">
                <constraints nullable="true"/>
            </column>
        </createTable>
    </changeSet>

    <changeSet id="create_employee_schedule" author="db@user">
        <createTable tableName="employee_schedule">
            <column name="employeeId" type="int">
                <constraints nullable="true"/>
            </column>
            <column name="flightId" type="int">
                <constraints nullable="true"/>
            </column>
            <column name="startDate" type="timestamp" defaultValue="0000-00-00 00:00:00">
                <constraints nullable="false"/>
            </column>
            <column name="endDate" type="timestamp" defaultValue="0000-00-00 00:00:00">
                <constraints nullable="false"/>
            </column>
            <column name="startLocation" type="varchar(50)">
                <constraints nullable="true"/>
            </column>
            <column name="endLocation" type="varchar(50)">
                <constraints nullable="true"/>
            </column>
        </createTable>
    </changeSet>
    
    <changeSet id="create_users" author="db@user">
        <createTable tableName="users">
            <column name="user_id" type="int" autoIncrement="true">
                <constraints primaryKey="true" unique="true" nullable="false"/>
            </column>
            <column name="user_name" type="varchar(50)">
                <constraints unique="true" nullable="true"/>
            </column>
            <column name="user_email" type="varchar(50)">
                <constraints unique="true" nullable="true"/>
            </column>
            <column name="user_password" type="varchar(50)">
                <constraints nullable="true"/>
            </column>
            <column name="user_role" type="enum ('ADMINISTRATOR', 'DISPATCHER')">
                <constraints nullable="true"/>
            </column>
        </createTable>
    </changeSet>

    <changeSet id="tag-1.0" author="db@user">
        <tagDatabase tag="1.0"/>
    </changeSet>

</databaseChangeLog>